--- grade/edit/tree/category_form.php	2010-06-23 18:42:55.000000000 -0700
+++ /home/cmoore/moodles/hidestuff/grade/edit/tree/category_form.php	2010-06-24 12:33:25.000000000 -0700
@@ -100,10 +100,11 @@
         $mform->disabledIf('keephigh', 'droplow', 'noteq', 0);
         $mform->disabledIf('droplow', 'keephigh', 'noteq', 0);
 
-        // Grade item settings
-        $mform->addElement('header', 'general', get_string('gradeitem', 'grades'));
+        // Category Total settings (was called Grade Item, misleadingly)
+        $mform->addElement('header', 'general', get_string('categorytotal', 'grades')); // CLAMP #225 2010-06-24 cmoore
 
-        $mform->addElement('text', 'grade_item_itemname', get_string('itemname', 'grades'));
+        $mform->addElement('text', 'grade_item_itemname', get_string('categorytotalname', 'grades')); // CLAMP #225 2010-06-24 cmoore
+	$mform->setAdvanced('grade_item_itemname'); // CLAMP #225 2010-06-24 cmoore
         $mform->addElement('text', 'grade_item_iteminfo', get_string('iteminfo', 'grades'));
         $mform->setHelpButton('grade_item_iteminfo', array('iteminfo', get_string('iteminfo', 'grades'), 'grade'), true);
 
@@ -118,6 +119,7 @@
         $mform->addElement('select', 'grade_item_gradetype', get_string('gradetype', 'grades'), $options);
         $mform->setHelpButton('grade_item_gradetype', array('gradetype', get_string('gradetype', 'grades'), 'grade'), true);
         $mform->setDefault('grade_item_gradetype', GRADE_TYPE_VALUE);
+	$mform->setAdvanced('grade_item_gradetype'); // CLAMP #225 2010-06-24 cmoore
         $mform->disabledIf('grade_item_gradetype', 'aggregation', 'eq', GRADE_AGGREGATE_SUM);
 
         //$mform->addElement('text', 'calculation', get_string('calculation', 'grades'));
@@ -144,16 +146,19 @@
 
         $mform->addElement('select', 'grade_item_scaleid', get_string('scale'), $options);
         $mform->setHelpButton('grade_item_scaleid', array('scaleid', get_string('scaleid', 'grades'), 'grade'), true);
+	$mform->setAdvanced('grade_item_scaleid'); // CLAMP #225 2010-06-24 cmoore
         $mform->disabledIf('grade_item_scaleid', 'grade_item_gradetype', 'noteq', GRADE_TYPE_SCALE);
         $mform->disabledIf('grade_item_scaleid', 'aggregation', 'eq', GRADE_AGGREGATE_SUM);
 
         $mform->addElement('text', 'grade_item_grademax', get_string('grademax', 'grades'));
         $mform->setHelpButton('grade_item_grademax', array('grademax', get_string('grademax', 'grades'), 'grade'), true);
+	//$mform->setAdvanced('grade_item_grademax'); // CLAMP #225 2010-06-24 cmoore
         $mform->disabledIf('grade_item_grademax', 'grade_item_gradetype', 'noteq', GRADE_TYPE_VALUE);
         $mform->disabledIf('grade_item_grademax', 'aggregation', 'eq', GRADE_AGGREGATE_SUM);
 
         $mform->addElement('text', 'grade_item_grademin', get_string('grademin', 'grades'));
         $mform->setHelpButton('grade_item_grademin', array('grademin', get_string('grademin', 'grades'), 'grade'), true);
+	$mform->setAdvanced('grade_item_grademin'); // CLAMP #225 2010-06-24 cmoore
         $mform->disabledIf('grade_item_grademin', 'grade_item_gradetype', 'noteq', GRADE_TYPE_VALUE);
         $mform->disabledIf('grade_item_grademin', 'aggregation', 'eq', GRADE_AGGREGATE_SUM);
 
@@ -202,6 +207,7 @@
         // advcheckbox is not compatible with disabledIf!
         $mform->addElement('checkbox', 'grade_item_hidden', get_string('hidden', 'grades'));
         $mform->setHelpButton('grade_item_hidden', array('hidden', get_string('hidden', 'grades'), 'grade'));
+	$mform->setAdvanced('grade_item_hidden'); // CLAMP #225 2010-06-24 cmoore
         $mform->addElement('date_time_selector', 'grade_item_hiddenuntil', get_string('hiddenuntil', 'grades'), array('optional'=>true));
         $mform->setHelpButton('grade_item_hiddenuntil', array('hiddenuntil', get_string('hiddenuntil', 'grades'), 'grade'));
         $mform->disabledIf('grade_item_hidden', 'grade_item_hiddenuntil[off]', 'notchecked');
@@ -209,6 +215,7 @@
         /// locking
         $mform->addElement('checkbox', 'grade_item_locked', get_string('locked', 'grades'));
         $mform->setHelpButton('grade_item_locked', array('locked', get_string('locked', 'grades'), 'grade'));
+	$mform->setAdvanced('grade_item_locked'); // CLAMP #225 2010-06-24 cmoore
 
         $mform->addElement('date_time_selector', 'grade_item_locktime', get_string('locktime', 'grades'), array('optional'=>true));
         $mform->setHelpButton('grade_item_locktime', array('lockedafter', get_string('locktime', 'grades'), 'grade'));

--- lang/en_utf8/grades.php	2010-06-23 18:43:08.000000000 -0700
+++ /home/cmoore/moodles/hidestuff/lang/en_utf8/grades.php	2010-06-24 11:59:30.000000000 -0700
@@ -71,6 +71,7 @@
 $string['categoryedit'] = 'Edit category';
 $string['categoryname'] = 'Category name';
 $string['categorytotal'] = 'Category total';
+$string['categorytotalname'] = 'Category total name'; // CLAMP #225 2010-06-24 cmoore
 $string['categorytotalfull'] = '$a->category total';
 $string['changereportdefaults'] = 'Change report defaults';
 $string['changedefaults'] = 'Change defaults';