Index: moodle/course/lib.php
--- moodle/course/lib.php Base (1.745)
+++ moodle/course/lib.php Locally Modified (Based On 1.745)
@@ -1435,7 +1435,7 @@
 
                     echo '<a '.$linkcss.' '.$extra.
                          ' href="'.$CFG->wwwroot.'/mod/'.$mod->modname.'/view.php?id='.$mod->id.'">'.
-                         '<img src="'.$icon.'" class="activityicon" alt="" /> '.
+                         '<img src="'.$icon.'" class="activityicon" alt="'.get_string('modulename',$mod->modname).'" /> '.
                          $accesstext.'<span>'.$instancename.$altname.'</span></a>';
 
                     if (!empty($mod->groupingid) && has_capability('moodle/course:managegroups', get_context_instance(CONTEXT_COURSE, $course->id))) {
@@ -1448,7 +1448,7 @@
                     // Display greyed-out text of link
                     echo '<span class="dimmed_text" '.$extra.' ><span class="accesshide">'.
                         get_string('notavailableyet','condition').': </span>'.
-                        '<img src="'.$icon.'" class="activityicon" alt="" /> <span>'.
+                        '<img src="'.$icon.'" class="activityicon" alt="'.get_string('modulename', $mod->modname).'" /> <span>'.
                         $instancename.$altname.'</span></span>';
                 }
             }

Index: moodle/course/resources.php
--- moodle/course/resources.php Base (1.8)
+++ moodle/course/resources.php Locally Modified (Based On 1.8)
@@ -125,9 +125,9 @@
 
     $extra = empty($cm->extra) ? '' : $cm->extra;
     if (!empty($cm->icon)) {
-        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="" /> ';
+        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="'.get_string('modulename', $cm->modname).'" /> ';
     } else {
-        $icon = '<img src="'.$OUTPUT->pix_url('icon', $cm->modname).'" class="activityicon" alt="" /> ';
+        $icon = '<img src="'.$OUTPUT->pix_url('icon', $cm->modname).'" class="activityicon" alt="'.get_string('modulename', $cm->modname).'" /> ';
     }
 
     $class = $cm->visible ? '' : 'class="dimmed"'; // hidden modules are dimmed
Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.147)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.147)
@@ -1367,9 +1367,9 @@
                 continue;
             }
             if ($cm->icon) {
-                $icon = new pix_icon($cm->icon, '', $cm->iconcomponent);
+                $icon = new pix_icon($cm->icon, get_string('modulename', $cm->modname), $cm->iconcomponent);
             } else {
-                $icon = new pix_icon('icon', '', $cm->modname);
+                $icon = new pix_icon('icon', get_string('modulename', $cm->modname), $cm->modname);
             }
             $url = new moodle_url('/mod/'.$cm->modname.'/view.php', array('id'=>$cm->id));
             $activitynode = $sectionnode->add($cm->name, $url, navigation_node::TYPE_ACTIVITY, $cm->name, $cm->id, $icon);
Index: moodle/mod/resource/index.php
--- moodle/mod/resource/index.php Base (1.44)
+++ moodle/mod/resource/index.php Locally Modified (Based On 1.44)
@@ -91,7 +91,7 @@
     $icon = '';
     if (!empty($cm->icon)) {
         // each resource file has an icon in 2.0
-        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="" /> ';
+        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="'.get_string('modulename', $cm->modname).'" /> ';
     }
 
     $class = $resource->visible ? '' : 'class="dimmed"'; // hidden modules are dimmed
Index: moodle/mod/url/index.php
--- moodle/mod/url/index.php Base (1.8)
+++ moodle/mod/url/index.php Locally Modified (Based On 1.8)
@@ -91,7 +91,7 @@
     $icon = '';
     if (!empty($cm->icon)) {
         // each url has an icon in 2.0
-        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="" /> ';
+        $icon = '<img src="'.$OUTPUT->pix_url($cm->icon).'" class="activityicon" alt="'.get_string('modulename', $cm->modname).'" /> ';
     }
 
     $class = $url->visible ? '' : 'class="dimmed"'; // hidden modules are dimmed